layui.define(['jquery', 'form', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var form = layui.form;
    var utils = layui.formUtils;
    var formField = layui.formField;

    var HTML_ARRAY = [
        '<div id="{0}Box" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">',
        '   <label class="layui-form-label {0}" style="width: {3}px;"><span style="color:red;">{2}</span>{1}:</label>',
        '   <div id="{0}Block" class="layui-input-block layui-form" lay-filter="{0}" style="margin-left: {1}px">',
        '       <select name="{0}" lay-verify="{2}" {1} >',
        '           <option value="{0}" selected="">{1}</option>',
        '           <option value="{0}">{1}</option>',
        '       </select>',
        '   </div>',
        '</div>'
    ];

    var select = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _required = json.required ? 'required' : '';
            var _html = HTML_ARRAY[0].format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += HTML_ARRAY[1].format(json.required ? 'layui-form-required' : '', json.label, json.required ? '*' : '', json.labelWidth);
            _html += HTML_ARRAY[2].format(json.id, json.labelWidth);
            _html += HTML_ARRAY[3].format(json.id, _disabled, _required);
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += HTML_ARRAY[4].format(json.options[i].value, json.options[i].text);
                } else {
                    _html += HTML_ARRAY[5].format(json.options[i].value, json.options[i].text);
                }
            }
            _html += HTML_ARRAY[6]
            _html += HTML_ARRAY[7];
            _html += HTML_ARRAY[8];
            return _html;
        },
        update: function (json) {
            var _disabled = json.disabled ? 'disabled=""' : '';
            var _required = json.required ? 'required' : '';
            var $block = $('#' + json.id + 'Box .layui-input-block');
            var $label = $('#' + json.id + 'Box .layui-form-label');
            $block.empty();
            $label.empty();
            var _html = '';
            _html += '<select name="{0}" lay-verify="{2}" {1}>'.format(json.id, _disabled, _required);
            for (var i = 0; i < json.options.length; i++) {
                if (json.options[i].checked) {
                    _html += HTML_ARRAY[4].format(json.options[i].value, json.options[i].text);
                } else {
                    _html += HTML_ARRAY[5].format(json.options[i].value, json.options[i].text);
                }
            }
            _html += '</select>'
            $('#' + json.id + 'Box .layui-input-block').append(_html);
            $block.css("margin-left", json.labelWidth);
            $label.css("width", json.labelWidth);
            if (json.required) {
                $label.append('<span style="color:red;">*</span>');
            }
            $label.append(json.label + ":");
            form.render('select', json.id);
            $('#' + json.id + 'Box .layui-input-block div.layui-unselect.layui-form-select').css({
                width: '{0}'.format(json.width)
            });
            $block.css({
                width: 'calc({0} - {1}px)'.format(json.width, json.labelWidth)
            });
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.select));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        }
    };

    exports('select', select);
});